;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname Hausi6_231117) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f () #f)))
(require 2htdp/image)
(require 2htdp/universe)

; ---------
; AUFGABE 1
; ---------


; A Speed is a Number.
; interp. speed of cat in pixels per tick.
(define VERY-FAST 20)
(define NORMAL 10)
(define SLOW 1)

; A Location is a structure: (make-posn Number Number)
; interp. x and y coordinate of a location on screen.
(define LEFT-TOP (make-posn 10 10))
(define RIGHT-TOP (make-posn 200 10))
(define LEFT-DOWN (make-posn 10 250))



; A WorldState is a structure:
; (make-world-state Speed Location Location)
; interp. current speed of cat, current location of cat, current location of food
(define-struct world-state (speed cat food))

(define EXAMPLE-1 (make-world-state VERY-FAST LEFT-TOP RIGHT-TOP))
(define EXAMPLE-2 (make-world-state 15 (make-posn 40 30) (make-posn 100 80)))

  
; A MouseEvent is one of
; - "button-down"
; - "button-up"
; - "drag"
; - "move"
; - "enter"
; - "leave"
; interp. mouse events, e.g., mouse movements or mouse clicks
; only "button-down" and "move" are used in this program
(define EVENT-1 "button-down")
(define DRAG "drag")
(define END-EVENT "leave")

; ZEROVECTOR is a posn
; interp. a 2d vector with x=y=0
(define ZEROVECTOR (make-posn 0 0))

; CATRADIUS is a number
; interp. the radius of CAT-IMG in pixels
(define CATRADIUS 20)

; CAT is an image
; interp. the image of a cat
(define CAT-IMG (circle  CATRADIUS "solid" "black"))

; FOOD is an image
; interp. the image of the cat's food
(define FOOD-IMG (square 20 "solid" "blue"))

; PLAYGROUND is an image
; interp. the space where CAT and FOOD can be placed in
(define PLAYGROUND (empty-scene 600 600))


; INITIAL-STATE
;
; WorldState
; An initial state we can start the game with
(define INITIAL-STATE (make-world-state 5 (make-posn 50 50) (make-posn 400 400)))

; draw
;
; WorldState -> Image
; Draw the cat and its food at their location
(check-expect (draw (make-world-state 50 (make-posn 10 20) (make-posn 70 90)))
              (place-image CAT-IMG 10 20
                           (place-image FOOD-IMG 70 90
                                        PLAYGROUND)))

(define (draw state)
  (place-image CAT-IMG 
               (posn-x (world-state-cat state)) 
               (posn-y (world-state-cat state))
               (place-image FOOD-IMG
                            (posn-x (world-state-food state))
                            (posn-y (world-state-food state))
                            PLAYGROUND)))

; tick
;
; WorldState -> WorldState
; Move the cat towards its food
(check-expect (tick (make-world-state 1 ZEROVECTOR (make-posn 100 0)))
              (make-world-state 1 (make-posn 1 0) (make-posn 100 0)))
(check-expect (tick (make-world-state 0 (make-posn 5 5) (make-posn 10 5)))
              (make-world-state 0 (make-posn 5 5) (make-posn 10 5)))
(check-expect (tick (make-world-state 2 (make-posn 2 2) (make-posn 2 10)))
              (make-world-state 2 (make-posn 2 2) (make-posn 2 10)))
(check-expect (tick (make-world-state 3 (make-posn 2 2) (make-posn 52 2)))
              (make-world-state 3 (make-posn 5 2) (make-posn 52 2)))
(check-expect (tick (make-world-state 4 (make-posn 50 0) ZEROVECTOR))
              (make-world-state 4 (make-posn 46 0) ZEROVECTOR))

(define (tick state)
  (make-world-state (world-state-speed state)
                    (if (food-at-cat? state) (world-state-cat state)
                        (vector-addition (vector-scale (direction-vector (world-state-cat state)
                                                                         (world-state-food state))
                                                       (world-state-speed state))
                                         (world-state-cat state)))                                                       
                    (world-state-food state)))

; mouse
;
; WorldState Number Number MouseEvent -> WorldState
; Update the position of the food when the mouse moves
(check-expect (mouse (make-world-state 1 ZEROVECTOR (make-posn 100 0)) 13 14 "move")
              (make-world-state 1 ZEROVECTOR (make-posn 13 14)))
(check-expect (mouse (make-world-state 5 (make-posn 100 0) ZEROVECTOR) 48 63 "button-down")
              (make-world-state 6 (make-posn 100 0) ZEROVECTOR))
(check-expect (mouse (make-world-state 4 (make-posn 50 0) (make-posn 0 50)) 50 10 "button-down")
              (make-world-state 3 (make-posn 50 0) (make-posn 0 50)))
(check-expect (mouse (make-world-state 4 (make-posn 50 0) (make-posn 0 50)) 50 10 "button-up")
              (make-world-state 4 (make-posn 50 0) (make-posn 0 50)))


(define (mouse state x y event)
  (cond
    [(string=? event "move") (make-world-state (world-state-speed state) (world-state-cat state) (make-posn x y))]
    [(string=? event "button-down") (if (<= (length-vector(vectorA->B  (world-state-cat state) (make-posn x y))) CATRADIUS)
                                        [make-world-state (- (world-state-speed state) 1)
                                                          (world-state-cat state)
                                                          (world-state-food state)]
                                        [make-world-state (+ (world-state-speed state) 1)
                                                          (world-state-cat state)
                                                          (world-state-food state)])]
    [else (make-world-state (world-state-speed state) (world-state-cat state) (world-state-food state))]))
                                      
                                      

; WorldState -> WorldState
; Starts the game
(define (cat-game initial-state)
  (big-bang initial-state
            [to-draw draw]
            [on-tick tick]
            [on-mouse mouse]))

; food-at-cat?
; WorldState -> Boolean
; checks if the food is in range of the cat
(check-expect (food-at-cat? (make-world-state 5 (make-posn 50 50) (make-posn 60 60))) #true)
(check-expect (food-at-cat? (make-world-state 4 ZEROVECTOR (make-posn 20 30))) #false)

(define (food-at-cat? state)
  (<= (length-vector (vectorA->B (world-state-cat state) (world-state-food state))) CATRADIUS) )
      


; vector-scale
; posn number -> posn
; scales the length of vector by number, doesn't change its direction
(check-expect (vector-scale (make-posn 2 5) 3) (make-posn 6 15))
(check-expect (vector-scale (make-posn 2 5) 0) ZEROVECTOR)

(define (vector-scale vector number)
  (make-posn (* (posn-x vector) number)
             (* (posn-y vector) number)))


; vector-addition
; posn posn -> posn
; adds a vector1 to vector2
(check-expect (vector-addition (make-posn 5 9) (make-posn 3 4)) (make-posn 8 13))

(define (vector-addition vector1 vector2)
  (make-posn (+ (posn-x vector1) (posn-x vector2))
             (+ (posn-y vector1) (posn-y vector2))))



; vectorA->B
; posn posn -> posn
; make a vector from pos1 to pos2
(check-expect (vectorA->B (make-posn 2 3) (make-posn 4 5)) (make-posn 2 2))

(define (vectorA->B pos1 pos2)
  (make-posn (- (posn-x pos2) (posn-x pos1))
             (- (posn-y pos2) (posn-y pos1))))

; direction-vector
; posn posn -> posn
; make a vector from length 1 pointing from pos1 to pos2
(check-expect (direction-vector (make-posn 2 5) (make-posn 8 5)) (make-posn 1 0))
(check-expect (direction-vector (make-posn 1 4) (make-posn 1 42)) (make-posn 0 1))
(check-expect (direction-vector (make-posn 5 5) (make-posn 5 5)) ZEROVECTOR)

(define (direction-vector pos1 pos2)
  (if (and
       (= (posn-x pos1) (posn-x pos2))
       (= (posn-y pos1) (posn-y pos2)))
      ZEROVECTOR
      (normalize-vector
       (vectorA->B pos1 pos2))))
  
; normalize-vector
; posn -> posn
; normalize a vector to make its length = 1
(check-expect (normalize-vector (make-posn 5 0)) (make-posn 1 0))
(check-expect (normalize-vector (make-posn 0 6)) (make-posn 0 1))

(define (normalize-vector vector)
  (make-posn (/ (posn-x vector) (length-vector vector))
             (/ (posn-y vector) (length-vector vector))))


; length-vector
; posn -> number
; compute the length of a given vector
(check-expect (length-vector (make-posn 4 3)) 5)
(check-expect (length-vector ZEROVECTOR) 0)
(check-expect (length-vector (make-posn 0 2)) 2)

(define (length-vector vector)
  (sqrt (+ (sqr (posn-x vector)) (sqr (posn-y vector)))))


; ---------
; Aufgabe 2
; ---------

; A Player is a struct:
; (make-player character level weapon ability)
; interp. the player of a role playing game.

(define-struct player (character level weapon ability))

; A character is one of:
; - "warrior"
; - "amazon"
; - "mage"
; interp. different looks and different primary abilities
;  Warrior -> primary ability is strength
;  Amazon -> primary ability is agility
;  Mage -> primary ability is intelligence


; A level is a number that falls into the interval
; -greater or equal than 1 and less or equal than 60
; interp. the progress a player made in the game
(define HIGH-LEVEL 60)
(define AVERAGE-LEVEL 23)
(define LOW-LEVEL 0)

; A weapon is one of
; - a struct: (make-weapon type MaxDmg MinDmg APS)
; - #false
; interp. the weapon a player can use at the moment, or no weapon

(define-struct weapon (type MaxDmg MinDmg APS))

(define SWORD (make-weapon "sword" 50 150 10))
(define WAND (make-weapon "wand" 40 200 4))
(define BOW (make-weapon "bow" 10 100 50))
(define NO-WEAPON #false)

; A type is one of:
; - "sword"
; - "bow"
; - "wand"
; interp. the weapon a player is using or #false

; MaxDmg is a Number that falls into the interval:
; - more or equal than 0 and less or equal than 200
; interp. the maximal Damage a Weapon can inflict
(define HIGH-DMG 150)

; MinDmg is a Number that falls into the interval:
; - more or equal than 0 and less or equal than 200
; interp. the minimal Damage a Weapon can inflict
(define LOW-DMG 50)

; APS is a Number that falls into the interval:
; - more or equal than 0 and less or equal than 200
; interp. the attacks per second a weapon can produce
(define FAST-ATTACK 150)
(define SLOW-ATTACK 50)


; An Attribute is a Number that falls into the interval:
;  - greater or equal than 0 and less or equal than 200
; interp. attributes of a player that change the abilities of its character
(define HIGH-ATTRIBUTE 150)
(define AVERAGE-ATTRIBUTE 100)
(define LOW-ATTRIBUTE 50)

; An ability is a struct:
; (make-struct strength agility intelligence vitality energy)
; interp. the different abilitites of a player, measured in attributes
(define-struct ability (strength agility intelligence vitality energy))

(define HIGH-ABILITIES (make-ability HIGH-ATTRIBUTE AVERAGE-ATTRIBUTE LOW-ATTRIBUTE AVERAGE-ATTRIBUTE HIGH-ATTRIBUTE))
(define AVERAGE-ABILITIES (make-ability AVERAGE-ATTRIBUTE AVERAGE-ATTRIBUTE HIGH-ATTRIBUTE LOW-ATTRIBUTE AVERAGE-ATTRIBUTE))
(define LOW-ABILITIES (make-ability AVERAGE-ATTRIBUTE LOW-ATTRIBUTE HIGH-ATTRIBUTE AVERAGE-ATTRIBUTE LOW-ATTRIBUTE))

; A feature is one of:
; - "mana"
; - "life"
; interp. a characteristic of a player, computed from player-own-values and character-specific-values
; used in the last part of AUFGABE 2

; DPS is a Number greater than 0.
; interp. the damage a player can inflict per second.
(define DPS-WITHOUT-WEAPON 0)
(define HIGH-DPS 150)


(define WARRIOR-WITH-WEAPON (make-player "warrior" HIGH-LEVEL SWORD HIGH-ABILITIES))
(define AMAZON-WITH-WEAPON (make-player "amazon" AVERAGE-LEVEL BOW AVERAGE-ABILITIES))
(define MAGE-WITH-WEAPON (make-player "mage" LOW-LEVEL WAND LOW-ABILITIES))
(define WARRIOR-WITHOUT-WEAPON (make-player "warrior" LOW-LEVEL #false AVERAGE-ABILITIES))
(define AMAZON-WITHOUT-WEAPON (make-player "amazon" HIGH-LEVEL #false HIGH-ABILITIES))
(define MAGE-WITHOUT-WEAPON (make-player "mage" AVERAGE-LEVEL #false LOW-ABILITIES))


; Template-Player
; player -> ...
; Template for a function that uses player as input
(define (template-player p)
  (...(player-character p)...(player-level-p)...(player-weapon p)...(player-ability p)...(player? p)...))

;Template-player-character
; character -> ...
; Template for a function that uses a player's character as input
(define (template-player-character p)  
  (cond
    [(string=? "warrior" (player-character p)) ...]
    [(string=? "amazon" (player-character p)) ...]
    [(string=? "mage" (player-character p)) ...]
    [(player? (player-character p)) ...]))

;Template-player-weapon
; weapon -> ...
; Template of a function that uses a player's weapon as input
(define (template-player-weapon p)
  (...(weapon-type (player-weapon p))...(weapon-MaxDmg (player-weapon p))
      ...(weapon-MinDmg (player-weapon p))...(weapon-APS (player-weapon p))...(player-weapon? p)))

; Template-player-weapon-type 
; weapon-type -> ...
; Template of a function that uses a player's weapon type as input
(define (template-player-weapon-type p)
  (cond
    [(string=? "sword" (weapon-type (player-weapon p)))...]
    [(string=? "bow" (weapon-type (player-weapon p)))...]
    [(string=? "wand" (weapon-type (player-weapon p)))...]
    [(false? (weapon-type (player-weapon p)))...]))

;Template-player-ability
; ability -> ...
; Template of a function that uses a player's ability as input
(define (template-player-ability p)
  (...(ability-strength (player-ability p))...(ability-agility (player-ability p))...(ability-intelligence (player-aility p))
      ...(ability-vitality (player-ability p))...(ability-energy (player-ability p))...(player-ability? p)))

; Template-player-feature
; feature -> ---
; Template of a function that uses a player's feature (e.g. life, mana) as input
(define (template-player-feature f)
  (cond [(string=? "life" f) ...]
        [(string=? "mana" f) ...]))

; damage-per-second
;
; player -> DPS
; returns the average damage per second a player can perform
(check-expect (damage-per-second WARRIOR-WITH-WEAPON) 2500)
(check-expect (damage-per-second WARRIOR-WITHOUT-WEAPON) 0)
(check-expect (damage-per-second MAGE-WITH-WEAPON) 1200)
(check-expect (damage-per-second AMAZON-WITH-WEAPON) 5500)

(define (damage-per-second player)
  (if (false? (player-weapon player)) 0
      (* (average (weapon-MaxDmg (player-weapon player)) (weapon-MinDmg (player-weapon player)))
         (weapon-APS (player-weapon player))
         (influence-of-primary-to-DPS player))))


; Mana is a Number greater than 0
; interp. the mana points a player can have

; Player -> Mana
; returns the maximum mana of a player
(check-expect (max-mana WARRIOR-WITH-WEAPON) 209)
(check-expect (max-mana AMAZON-WITH-WEAPON) 175.5)
(check-expect (max-mana MAGE-WITHOUT-WEAPON) 109)

(define (max-mana player)
  (cut-under-0 (+ (start-energy player)
                        (* (energy-bonus player)
                           (+ (player-level player)
                              (- (ability-energy (player-ability player))
                                 1
                                 (start-energy player)))))))

     

; Life is a Number greater than 0
; interp. the life points a player can have

; Player -> Life
; returns the maximum life of a player
(check-expect (max-life WARRIOR-WITH-WEAPON) 516)
(check-expect (max-life AMAZON-WITH-WEAPON) 176)
(check-expect (max-life MAGE-WITH-WEAPON) 183)
 
(define (max-life player)
  (cut-under-0 (+ (start-vitality player)
                        (* (vitality-bonus player)
                           (+ (player-level player)
                              (- (ability-vitality (player-ability player))
                                 1
                                 (start-vitality player)))))))

; cut-under-0
;
; number -> number
; changes a number < 0 to 0, doesn't change numbers > 0
(check-expect (cut-under-0 -52) 0)
(check-expect (cut-under-0 0) 0)
(check-expect (cut-under-0 19) 19)

(define (cut-under-0 number)
  (if (< number 0) 0 number))


; start-vitality
;
; Player -> number
; determines the "start-vitality" for each character
(check-expect (start-vitality WARRIOR-WITHOUT-WEAPON) 40)
(check-expect (start-vitality MAGE-WITH-WEAPON) 15)
(check-expect (start-vitality AMAZON-WITH-WEAPON) 20)

(define (start-vitality p)  
  (cond
    [(string=? "warrior" (player-character p)) 40]
    [(string=? "amazon" (player-character p)) 20]
    [(string=? "mage" (player-character p)) 15]))

; vitality-bonus
;
; Player -> number
; determines the "vitality-bonus" for each character
(check-expect (vitality-bonus WARRIOR-WITHOUT-WEAPON) 4)
(check-expect (vitality-bonus MAGE-WITH-WEAPON) 2)
(check-expect (vitality-bonus AMAZON-WITH-WEAPON) 3)

(define (vitality-bonus p)  
  (cond
    [(string=? "warrior" (player-character p)) 4]
    [(string=? "amazon" (player-character p)) 3]
    [(string=? "mage" (player-character p)) 2]))


; Start-Energy
;
; Player -> number
; determines the "Start-Energy" for each character
(check-expect (start-energy WARRIOR-WITHOUT-WEAPON) 10)
(check-expect (start-energy MAGE-WITH-WEAPON) 35)
(check-expect (start-energy AMAZON-WITH-WEAPON) 15)

(define (start-energy p)  
  (cond
    [(string=? "warrior" (player-character p)) 10]
    [(string=? "amazon" (player-character p)) 15]
    [(string=? "mage" (player-character p)) 35]))

; Energy-Bonus
;
; Player -> number
; determines the "energy-bonus" for each character
(check-expect (energy-bonus WARRIOR-WITHOUT-WEAPON) 1)
(check-expect (energy-bonus MAGE-WITH-WEAPON) 2)
(check-expect (energy-bonus AMAZON-WITH-WEAPON) 1.5)

(define (energy-bonus p)  
  (cond
    [(string=? "warrior" (player-character p)) 1]
    [(string=? "amazon" (player-character p)) 1.5]
    [(string=? "mage" (player-character p)) 2]))



; Influence-of-primary-to-DPS
;
; Player -> number
; computes (1 + (primaryAttribute/100), what is needed to compute a player's DPS
(check-expect (influence-of-primary-to-DPS WARRIOR-WITH-WEAPON) 2.5)
(check-expect (influence-of-primary-to-DPS AMAZON-WITHOUT-WEAPON) 2)
(check-expect (influence-of-primary-to-DPS MAGE-WITH-WEAPON) 2.5)

(define (influence-of-primary-to-DPS p) 
  (+ 1 (/ (cond
            [(string=? "warrior" (player-character p)) (ability-strength (player-ability p))]
            [(string=? "amazon" (player-character p)) (ability-agility (player-ability p))]
            [(string=? "mage" (player-character p)) (ability-intelligence (player-ability p))])
          100)))

; average
;
; number number -> number
; computes the average of two numbers
(check-expect (average 50 0) 25)
(check-expect (average 2 4) 3)

(define (average num1 num2)
  (* 0.5 (+ num1 num2)))





